package es.ucm.fdi.grasia.faerie.container.internal.local.test;

import java.net.URI;
import java.util.UUID;

import org.apache.felix.ipojo.junit4osgi.OSGiTestCase;

import es.ucm.fdi.grasia.faerie.container.ContextContainer;
import es.ucm.fdi.grasia.faerie.core.AbstractAttribute;
import es.ucm.fdi.grasia.faerie.core.AbstractEntity;
import es.ucm.fdi.grasia.faerie.core.ContextElement;
import es.ucm.fdi.grasia.faerie.core.Entity;
import es.ucm.fdi.grasia.faerie.core.util.ContextURIs;

public class LocalContextContainerTest extends OSGiTestCase {

	private ContextContainer tested;

	@Override
	public void setUp() {
		System.out.println("setUp");
		tested = (ContextContainer) this.getServiceObject(ContextContainer.class.getName(), null);
	}

	public static class TestEntity extends AbstractEntity {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		public TestEntity(URI authority, URI path, URI name) {
			super(authority, path, name);
		}
	}

	public static class TestAttribute extends AbstractAttribute<Entity, Object> {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		public TestAttribute(Entity entity) {
			super(entity);
		}
	}

	private class TestAttribute2 extends AbstractAttribute<Entity, Object> {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		public TestAttribute2(Entity entity) {
			super(entity);
		}
	}

	public void testRequest_ContextElement_UUID() {
		System.out.println("request_ContextElement_UUID");
		TestEntity entity = new TestEntity(ContextURIs.authorityURI(ContextURIs.localURI()), URI.create("/tests/"),
				URI.create("e1"));
		TestAttribute element = new TestAttribute(entity);
		UUID requesterId = UUID.randomUUID();
		ContextElement result = tested.request(element, requesterId);
		assertTrue(result instanceof TestAttribute);
		TestEntity entityCopy = new TestEntity(ContextURIs.authorityURI(ContextURIs.localURI()), URI.create("/tests/"),
				URI.create("e1"));
		TestAttribute2 anotherElement = new TestAttribute2(entityCopy);
		TestAttribute2 anotherResult = tested.request(anotherElement, requesterId);
		Entity resultEntity = anotherResult.getEntity();
		assertEquals(resultEntity, entity);
		assertNotEquals(null, resultEntity, entityCopy);
		assertTrue(resultEntity.getAllAttributesInstances().size() == 2);
		TestAttribute yetAnotherElement = new TestAttribute(entityCopy);
		TestAttribute yetAnotherResult = tested.request(yetAnotherElement, requesterId);
		assertEquals(yetAnotherResult, result);
	}
}